import {ServiceParams, App as BaseApp, Endpoint, GetEndpointParams, Operation} from '../common';

export interface ClientParams<App extends BaseApp> {
	app: App;
	fetch?: typeof fetch;
}

export interface Client<App extends BaseApp = BaseApp> {
	app: App;
	connect(params: ServiceParams): this;
	at<TheEndpoint extends Endpoint = Endpoint>(endpoint: TheEndpoint, params?: Record<GetEndpointParams<TheEndpoint>, unknown>): this;
	makeRequest(operation: Operation): ReturnType<typeof fetch>;
}
